import { ATN } from "antlr4ts/atn/ATN";
import { CharStream } from "antlr4ts/CharStream";
import { Lexer } from "antlr4ts/Lexer";
import { Vocabulary } from "antlr4ts/Vocabulary";
export declare class EscriptLexer extends Lexer {
    static readonly IF = 1;
    static readonly THEN = 2;
    static readonly ELSEIF = 3;
    static readonly ENDIF = 4;
    static readonly ELSE = 5;
    static readonly GOTO = 6;
    static readonly RETURN = 7;
    static readonly TOK_CONST = 8;
    static readonly VAR = 9;
    static readonly DO = 10;
    static readonly DOWHILE = 11;
    static readonly WHILE = 12;
    static readonly ENDWHILE = 13;
    static readonly EXIT = 14;
    static readonly FUNCTION = 15;
    static readonly ENDFUNCTION = 16;
    static readonly EXPORTED = 17;
    static readonly USE = 18;
    static readonly INCLUDE = 19;
    static readonly BREAK = 20;
    static readonly CONTINUE = 21;
    static readonly FOR = 22;
    static readonly ENDFOR = 23;
    static readonly TO = 24;
    static readonly FOREACH = 25;
    static readonly ENDFOREACH = 26;
    static readonly REPEAT = 27;
    static readonly UNTIL = 28;
    static readonly PROGRAM = 29;
    static readonly ENDPROGRAM = 30;
    static readonly CASE = 31;
    static readonly DEFAULT = 32;
    static readonly ENDCASE = 33;
    static readonly ENUM = 34;
    static readonly ENDENUM = 35;
    static readonly DOWNTO = 36;
    static readonly STEP = 37;
    static readonly REFERENCE = 38;
    static readonly TOK_OUT = 39;
    static readonly INOUT = 40;
    static readonly BYVAL = 41;
    static readonly STRING = 42;
    static readonly TOK_LONG = 43;
    static readonly INTEGER = 44;
    static readonly UNSIGNED = 45;
    static readonly SIGNED = 46;
    static readonly REAL = 47;
    static readonly FLOAT = 48;
    static readonly DOUBLE = 49;
    static readonly AS = 50;
    static readonly IS = 51;
    static readonly AND_A = 52;
    static readonly AND_B = 53;
    static readonly OR_A = 54;
    static readonly OR_B = 55;
    static readonly BANG_A = 56;
    static readonly BANG_B = 57;
    static readonly BYREF = 58;
    static readonly UNUSED = 59;
    static readonly TOK_ERROR = 60;
    static readonly HASH = 61;
    static readonly DICTIONARY = 62;
    static readonly STRUCT = 63;
    static readonly ARRAY = 64;
    static readonly STACK = 65;
    static readonly TOK_IN = 66;
    static readonly DECIMAL_LITERAL = 67;
    static readonly HEX_LITERAL = 68;
    static readonly OCT_LITERAL = 69;
    static readonly BINARY_LITERAL = 70;
    static readonly FLOAT_LITERAL = 71;
    static readonly HEX_FLOAT_LITERAL = 72;
    static readonly CHAR_LITERAL = 73;
    static readonly STRING_LITERAL = 74;
    static readonly LPAREN = 75;
    static readonly RPAREN = 76;
    static readonly LBRACK = 77;
    static readonly RBRACK = 78;
    static readonly LBRACE = 79;
    static readonly RBRACE = 80;
    static readonly DOT = 81;
    static readonly ARROW = 82;
    static readonly MUL = 83;
    static readonly DIV = 84;
    static readonly MOD = 85;
    static readonly ADD = 86;
    static readonly SUB = 87;
    static readonly ADD_ASSIGN = 88;
    static readonly SUB_ASSIGN = 89;
    static readonly MUL_ASSIGN = 90;
    static readonly DIV_ASSIGN = 91;
    static readonly MOD_ASSIGN = 92;
    static readonly LE = 93;
    static readonly LT = 94;
    static readonly GE = 95;
    static readonly GT = 96;
    static readonly RSHIFT = 97;
    static readonly LSHIFT = 98;
    static readonly BITAND = 99;
    static readonly CARET = 100;
    static readonly BITOR = 101;
    static readonly NOTEQUAL_A = 102;
    static readonly NOTEQUAL_B = 103;
    static readonly EQUAL_DEPRECATED = 104;
    static readonly EQUAL = 105;
    static readonly ASSIGN = 106;
    static readonly ADDMEMBER = 107;
    static readonly DELMEMBER = 108;
    static readonly CHKMEMBER = 109;
    static readonly SEMI = 110;
    static readonly COMMA = 111;
    static readonly TILDE = 112;
    static readonly AT = 113;
    static readonly COLONCOLON = 114;
    static readonly COLON = 115;
    static readonly INC = 116;
    static readonly DEC = 117;
    static readonly ELVIS = 118;
    static readonly WS = 119;
    static readonly COMMENT = 120;
    static readonly LINE_COMMENT = 121;
    static readonly IDENTIFIER = 122;
    static readonly COMMENTS = 2;
    static readonly channelNames: string[];
    static readonly modeNames: string[];
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    get vocabulary(): Vocabulary;
    constructor(input: CharStream);
    get grammarFileName(): string;
    get ruleNames(): string[];
    get serializedATN(): string;
    get channelNames(): string[];
    get modeNames(): string[];
    private static readonly _serializedATNSegments;
    private static readonly _serializedATNSegment0;
    private static readonly _serializedATNSegment1;
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static get _ATN(): ATN;
}
