import { ATN } from "antlr4ts/atn/ATN";
import { Parser } from "antlr4ts/Parser";
import { ParserRuleContext } from "antlr4ts/ParserRuleContext";
import { RuleContext } from "antlr4ts/RuleContext";
import { TerminalNode } from "antlr4ts/tree/TerminalNode";
import { Token } from "antlr4ts/Token";
import { TokenStream } from "antlr4ts/TokenStream";
import { Vocabulary } from "antlr4ts/Vocabulary";
import { EscriptParserListener } from "./EscriptParserListener";
import { EscriptParserVisitor } from "./EscriptParserVisitor";
export declare class EscriptParser extends Parser {
    static readonly IF = 1;
    static readonly THEN = 2;
    static readonly ELSEIF = 3;
    static readonly ENDIF = 4;
    static readonly ELSE = 5;
    static readonly GOTO = 6;
    static readonly RETURN = 7;
    static readonly TOK_CONST = 8;
    static readonly VAR = 9;
    static readonly DO = 10;
    static readonly DOWHILE = 11;
    static readonly WHILE = 12;
    static readonly ENDWHILE = 13;
    static readonly EXIT = 14;
    static readonly FUNCTION = 15;
    static readonly ENDFUNCTION = 16;
    static readonly EXPORTED = 17;
    static readonly USE = 18;
    static readonly INCLUDE = 19;
    static readonly BREAK = 20;
    static readonly CONTINUE = 21;
    static readonly FOR = 22;
    static readonly ENDFOR = 23;
    static readonly TO = 24;
    static readonly FOREACH = 25;
    static readonly ENDFOREACH = 26;
    static readonly REPEAT = 27;
    static readonly UNTIL = 28;
    static readonly PROGRAM = 29;
    static readonly ENDPROGRAM = 30;
    static readonly CASE = 31;
    static readonly DEFAULT = 32;
    static readonly ENDCASE = 33;
    static readonly ENUM = 34;
    static readonly ENDENUM = 35;
    static readonly DOWNTO = 36;
    static readonly STEP = 37;
    static readonly REFERENCE = 38;
    static readonly TOK_OUT = 39;
    static readonly INOUT = 40;
    static readonly BYVAL = 41;
    static readonly STRING = 42;
    static readonly TOK_LONG = 43;
    static readonly INTEGER = 44;
    static readonly UNSIGNED = 45;
    static readonly SIGNED = 46;
    static readonly REAL = 47;
    static readonly FLOAT = 48;
    static readonly DOUBLE = 49;
    static readonly AS = 50;
    static readonly IS = 51;
    static readonly AND_A = 52;
    static readonly AND_B = 53;
    static readonly OR_A = 54;
    static readonly OR_B = 55;
    static readonly BANG_A = 56;
    static readonly BANG_B = 57;
    static readonly BYREF = 58;
    static readonly UNUSED = 59;
    static readonly TOK_ERROR = 60;
    static readonly HASH = 61;
    static readonly DICTIONARY = 62;
    static readonly STRUCT = 63;
    static readonly ARRAY = 64;
    static readonly STACK = 65;
    static readonly TOK_IN = 66;
    static readonly DECIMAL_LITERAL = 67;
    static readonly HEX_LITERAL = 68;
    static readonly OCT_LITERAL = 69;
    static readonly BINARY_LITERAL = 70;
    static readonly FLOAT_LITERAL = 71;
    static readonly HEX_FLOAT_LITERAL = 72;
    static readonly CHAR_LITERAL = 73;
    static readonly STRING_LITERAL = 74;
    static readonly LPAREN = 75;
    static readonly RPAREN = 76;
    static readonly LBRACK = 77;
    static readonly RBRACK = 78;
    static readonly LBRACE = 79;
    static readonly RBRACE = 80;
    static readonly DOT = 81;
    static readonly ARROW = 82;
    static readonly MUL = 83;
    static readonly DIV = 84;
    static readonly MOD = 85;
    static readonly ADD = 86;
    static readonly SUB = 87;
    static readonly ADD_ASSIGN = 88;
    static readonly SUB_ASSIGN = 89;
    static readonly MUL_ASSIGN = 90;
    static readonly DIV_ASSIGN = 91;
    static readonly MOD_ASSIGN = 92;
    static readonly LE = 93;
    static readonly LT = 94;
    static readonly GE = 95;
    static readonly GT = 96;
    static readonly RSHIFT = 97;
    static readonly LSHIFT = 98;
    static readonly BITAND = 99;
    static readonly CARET = 100;
    static readonly BITOR = 101;
    static readonly NOTEQUAL_A = 102;
    static readonly NOTEQUAL_B = 103;
    static readonly EQUAL_DEPRECATED = 104;
    static readonly EQUAL = 105;
    static readonly ASSIGN = 106;
    static readonly ADDMEMBER = 107;
    static readonly DELMEMBER = 108;
    static readonly CHKMEMBER = 109;
    static readonly SEMI = 110;
    static readonly COMMA = 111;
    static readonly TILDE = 112;
    static readonly AT = 113;
    static readonly COLONCOLON = 114;
    static readonly COLON = 115;
    static readonly INC = 116;
    static readonly DEC = 117;
    static readonly ELVIS = 118;
    static readonly WS = 119;
    static readonly COMMENT = 120;
    static readonly LINE_COMMENT = 121;
    static readonly IDENTIFIER = 122;
    static readonly RULE_compilationUnit = 0;
    static readonly RULE_moduleUnit = 1;
    static readonly RULE_moduleDeclarationStatement = 2;
    static readonly RULE_moduleFunctionDeclaration = 3;
    static readonly RULE_moduleFunctionParameterList = 4;
    static readonly RULE_moduleFunctionParameter = 5;
    static readonly RULE_topLevelDeclaration = 6;
    static readonly RULE_functionDeclaration = 7;
    static readonly RULE_stringIdentifier = 8;
    static readonly RULE_useDeclaration = 9;
    static readonly RULE_includeDeclaration = 10;
    static readonly RULE_programDeclaration = 11;
    static readonly RULE_statement = 12;
    static readonly RULE_statementLabel = 13;
    static readonly RULE_ifStatement = 14;
    static readonly RULE_gotoStatement = 15;
    static readonly RULE_returnStatement = 16;
    static readonly RULE_constStatement = 17;
    static readonly RULE_varStatement = 18;
    static readonly RULE_doStatement = 19;
    static readonly RULE_whileStatement = 20;
    static readonly RULE_exitStatement = 21;
    static readonly RULE_breakStatement = 22;
    static readonly RULE_continueStatement = 23;
    static readonly RULE_forStatement = 24;
    static readonly RULE_foreachIterableExpression = 25;
    static readonly RULE_foreachStatement = 26;
    static readonly RULE_repeatStatement = 27;
    static readonly RULE_caseStatement = 28;
    static readonly RULE_enumStatement = 29;
    static readonly RULE_block = 30;
    static readonly RULE_variableDeclarationInitializer = 31;
    static readonly RULE_enumList = 32;
    static readonly RULE_enumListEntry = 33;
    static readonly RULE_switchBlockStatementGroup = 34;
    static readonly RULE_switchLabel = 35;
    static readonly RULE_forGroup = 36;
    static readonly RULE_basicForStatement = 37;
    static readonly RULE_cstyleForStatement = 38;
    static readonly RULE_identifierList = 39;
    static readonly RULE_variableDeclarationList = 40;
    static readonly RULE_variableDeclaration = 41;
    static readonly RULE_programParameters = 42;
    static readonly RULE_programParameterList = 43;
    static readonly RULE_programParameter = 44;
    static readonly RULE_functionParameters = 45;
    static readonly RULE_functionParameterList = 46;
    static readonly RULE_functionParameter = 47;
    static readonly RULE_scopedFunctionCall = 48;
    static readonly RULE_functionReference = 49;
    static readonly RULE_expression = 50;
    static readonly RULE_primary = 51;
    static readonly RULE_explicitArrayInitializer = 52;
    static readonly RULE_explicitStructInitializer = 53;
    static readonly RULE_explicitDictInitializer = 54;
    static readonly RULE_explicitErrorInitializer = 55;
    static readonly RULE_bareArrayInitializer = 56;
    static readonly RULE_parExpression = 57;
    static readonly RULE_expressionList = 58;
    static readonly RULE_expressionSuffix = 59;
    static readonly RULE_indexingSuffix = 60;
    static readonly RULE_navigationSuffix = 61;
    static readonly RULE_methodCallSuffix = 62;
    static readonly RULE_functionCall = 63;
    static readonly RULE_structInitializerExpression = 64;
    static readonly RULE_structInitializerExpressionList = 65;
    static readonly RULE_structInitializer = 66;
    static readonly RULE_dictInitializerExpression = 67;
    static readonly RULE_dictInitializerExpressionList = 68;
    static readonly RULE_dictInitializer = 69;
    static readonly RULE_arrayInitializer = 70;
    static readonly RULE_literal = 71;
    static readonly RULE_integerLiteral = 72;
    static readonly RULE_floatLiteral = 73;
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    get vocabulary(): Vocabulary;
    get grammarFileName(): string;
    get ruleNames(): string[];
    get serializedATN(): string;
    constructor(input: TokenStream);
    compilationUnit(): CompilationUnitContext;
    moduleUnit(): ModuleUnitContext;
    moduleDeclarationStatement(): ModuleDeclarationStatementContext;
    moduleFunctionDeclaration(): ModuleFunctionDeclarationContext;
    moduleFunctionParameterList(): ModuleFunctionParameterListContext;
    moduleFunctionParameter(): ModuleFunctionParameterContext;
    topLevelDeclaration(): TopLevelDeclarationContext;
    functionDeclaration(): FunctionDeclarationContext;
    stringIdentifier(): StringIdentifierContext;
    useDeclaration(): UseDeclarationContext;
    includeDeclaration(): IncludeDeclarationContext;
    programDeclaration(): ProgramDeclarationContext;
    statement(): StatementContext;
    statementLabel(): StatementLabelContext;
    ifStatement(): IfStatementContext;
    gotoStatement(): GotoStatementContext;
    returnStatement(): ReturnStatementContext;
    constStatement(): ConstStatementContext;
    varStatement(): VarStatementContext;
    doStatement(): DoStatementContext;
    whileStatement(): WhileStatementContext;
    exitStatement(): ExitStatementContext;
    breakStatement(): BreakStatementContext;
    continueStatement(): ContinueStatementContext;
    forStatement(): ForStatementContext;
    foreachIterableExpression(): ForeachIterableExpressionContext;
    foreachStatement(): ForeachStatementContext;
    repeatStatement(): RepeatStatementContext;
    caseStatement(): CaseStatementContext;
    enumStatement(): EnumStatementContext;
    block(): BlockContext;
    variableDeclarationInitializer(): VariableDeclarationInitializerContext;
    enumList(): EnumListContext;
    enumListEntry(): EnumListEntryContext;
    switchBlockStatementGroup(): SwitchBlockStatementGroupContext;
    switchLabel(): SwitchLabelContext;
    forGroup(): ForGroupContext;
    basicForStatement(): BasicForStatementContext;
    cstyleForStatement(): CstyleForStatementContext;
    identifierList(): IdentifierListContext;
    variableDeclarationList(): VariableDeclarationListContext;
    variableDeclaration(): VariableDeclarationContext;
    programParameters(): ProgramParametersContext;
    programParameterList(): ProgramParameterListContext;
    programParameter(): ProgramParameterContext;
    functionParameters(): FunctionParametersContext;
    functionParameterList(): FunctionParameterListContext;
    functionParameter(): FunctionParameterContext;
    scopedFunctionCall(): ScopedFunctionCallContext;
    functionReference(): FunctionReferenceContext;
    expression(): ExpressionContext;
    expression(_p: number): ExpressionContext;
    primary(): PrimaryContext;
    explicitArrayInitializer(): ExplicitArrayInitializerContext;
    explicitStructInitializer(): ExplicitStructInitializerContext;
    explicitDictInitializer(): ExplicitDictInitializerContext;
    explicitErrorInitializer(): ExplicitErrorInitializerContext;
    bareArrayInitializer(): BareArrayInitializerContext;
    parExpression(): ParExpressionContext;
    expressionList(): ExpressionListContext;
    expressionSuffix(): ExpressionSuffixContext;
    indexingSuffix(): IndexingSuffixContext;
    navigationSuffix(): NavigationSuffixContext;
    methodCallSuffix(): MethodCallSuffixContext;
    functionCall(): FunctionCallContext;
    structInitializerExpression(): StructInitializerExpressionContext;
    structInitializerExpressionList(): StructInitializerExpressionListContext;
    structInitializer(): StructInitializerContext;
    dictInitializerExpression(): DictInitializerExpressionContext;
    dictInitializerExpressionList(): DictInitializerExpressionListContext;
    dictInitializer(): DictInitializerContext;
    arrayInitializer(): ArrayInitializerContext;
    literal(): LiteralContext;
    integerLiteral(): IntegerLiteralContext;
    floatLiteral(): FloatLiteralContext;
    sempred(_localctx: RuleContext, ruleIndex: number, predIndex: number): boolean;
    private expression_sempred;
    private static readonly _serializedATNSegments;
    private static readonly _serializedATNSegment0;
    private static readonly _serializedATNSegment1;
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static get _ATN(): ATN;
}
export declare class CompilationUnitContext extends ParserRuleContext {
    EOF(): TerminalNode;
    topLevelDeclaration(): TopLevelDeclarationContext[];
    topLevelDeclaration(i: number): TopLevelDeclarationContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ModuleUnitContext extends ParserRuleContext {
    EOF(): TerminalNode;
    moduleDeclarationStatement(): ModuleDeclarationStatementContext[];
    moduleDeclarationStatement(i: number): ModuleDeclarationStatementContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ModuleDeclarationStatementContext extends ParserRuleContext {
    moduleFunctionDeclaration(): ModuleFunctionDeclarationContext | undefined;
    constStatement(): ConstStatementContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ModuleFunctionDeclarationContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode;
    LPAREN(): TerminalNode;
    RPAREN(): TerminalNode;
    SEMI(): TerminalNode;
    moduleFunctionParameterList(): ModuleFunctionParameterListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ModuleFunctionParameterListContext extends ParserRuleContext {
    moduleFunctionParameter(): ModuleFunctionParameterContext[];
    moduleFunctionParameter(i: number): ModuleFunctionParameterContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ModuleFunctionParameterContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode;
    ASSIGN(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class TopLevelDeclarationContext extends ParserRuleContext {
    useDeclaration(): UseDeclarationContext | undefined;
    includeDeclaration(): IncludeDeclarationContext | undefined;
    programDeclaration(): ProgramDeclarationContext | undefined;
    functionDeclaration(): FunctionDeclarationContext | undefined;
    statement(): StatementContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class FunctionDeclarationContext extends ParserRuleContext {
    FUNCTION(): TerminalNode;
    IDENTIFIER(): TerminalNode;
    functionParameters(): FunctionParametersContext;
    block(): BlockContext;
    ENDFUNCTION(): TerminalNode;
    EXPORTED(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class StringIdentifierContext extends ParserRuleContext {
    STRING_LITERAL(): TerminalNode | undefined;
    IDENTIFIER(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class UseDeclarationContext extends ParserRuleContext {
    USE(): TerminalNode;
    stringIdentifier(): StringIdentifierContext;
    SEMI(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class IncludeDeclarationContext extends ParserRuleContext {
    INCLUDE(): TerminalNode;
    stringIdentifier(): StringIdentifierContext;
    SEMI(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ProgramDeclarationContext extends ParserRuleContext {
    PROGRAM(): TerminalNode;
    IDENTIFIER(): TerminalNode;
    programParameters(): ProgramParametersContext;
    block(): BlockContext;
    ENDPROGRAM(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class StatementContext extends ParserRuleContext {
    _statementExpression: ExpressionContext;
    ifStatement(): IfStatementContext | undefined;
    gotoStatement(): GotoStatementContext | undefined;
    returnStatement(): ReturnStatementContext | undefined;
    constStatement(): ConstStatementContext | undefined;
    varStatement(): VarStatementContext | undefined;
    doStatement(): DoStatementContext | undefined;
    whileStatement(): WhileStatementContext | undefined;
    exitStatement(): ExitStatementContext | undefined;
    breakStatement(): BreakStatementContext | undefined;
    continueStatement(): ContinueStatementContext | undefined;
    forStatement(): ForStatementContext | undefined;
    foreachStatement(): ForeachStatementContext | undefined;
    repeatStatement(): RepeatStatementContext | undefined;
    caseStatement(): CaseStatementContext | undefined;
    enumStatement(): EnumStatementContext | undefined;
    SEMI(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class StatementLabelContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode;
    COLON(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class IfStatementContext extends ParserRuleContext {
    IF(): TerminalNode;
    parExpression(): ParExpressionContext[];
    parExpression(i: number): ParExpressionContext;
    block(): BlockContext[];
    block(i: number): BlockContext;
    ENDIF(): TerminalNode;
    THEN(): TerminalNode | undefined;
    ELSEIF(): TerminalNode[];
    ELSEIF(i: number): TerminalNode;
    ELSE(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class GotoStatementContext extends ParserRuleContext {
    GOTO(): TerminalNode;
    IDENTIFIER(): TerminalNode;
    SEMI(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ReturnStatementContext extends ParserRuleContext {
    RETURN(): TerminalNode;
    SEMI(): TerminalNode;
    expression(): ExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ConstStatementContext extends ParserRuleContext {
    TOK_CONST(): TerminalNode;
    variableDeclaration(): VariableDeclarationContext;
    SEMI(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class VarStatementContext extends ParserRuleContext {
    VAR(): TerminalNode;
    variableDeclarationList(): VariableDeclarationListContext;
    SEMI(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class DoStatementContext extends ParserRuleContext {
    DO(): TerminalNode;
    block(): BlockContext;
    DOWHILE(): TerminalNode;
    parExpression(): ParExpressionContext;
    SEMI(): TerminalNode;
    statementLabel(): StatementLabelContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class WhileStatementContext extends ParserRuleContext {
    WHILE(): TerminalNode;
    parExpression(): ParExpressionContext;
    block(): BlockContext;
    ENDWHILE(): TerminalNode;
    statementLabel(): StatementLabelContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ExitStatementContext extends ParserRuleContext {
    EXIT(): TerminalNode;
    SEMI(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class BreakStatementContext extends ParserRuleContext {
    BREAK(): TerminalNode;
    SEMI(): TerminalNode;
    IDENTIFIER(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ContinueStatementContext extends ParserRuleContext {
    CONTINUE(): TerminalNode;
    SEMI(): TerminalNode;
    IDENTIFIER(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ForStatementContext extends ParserRuleContext {
    FOR(): TerminalNode;
    forGroup(): ForGroupContext;
    ENDFOR(): TerminalNode;
    statementLabel(): StatementLabelContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ForeachIterableExpressionContext extends ParserRuleContext {
    functionCall(): FunctionCallContext | undefined;
    scopedFunctionCall(): ScopedFunctionCallContext | undefined;
    IDENTIFIER(): TerminalNode | undefined;
    parExpression(): ParExpressionContext | undefined;
    bareArrayInitializer(): BareArrayInitializerContext | undefined;
    explicitArrayInitializer(): ExplicitArrayInitializerContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ForeachStatementContext extends ParserRuleContext {
    FOREACH(): TerminalNode;
    IDENTIFIER(): TerminalNode;
    TOK_IN(): TerminalNode;
    foreachIterableExpression(): ForeachIterableExpressionContext;
    block(): BlockContext;
    ENDFOREACH(): TerminalNode;
    statementLabel(): StatementLabelContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class RepeatStatementContext extends ParserRuleContext {
    REPEAT(): TerminalNode;
    block(): BlockContext;
    UNTIL(): TerminalNode;
    expression(): ExpressionContext;
    SEMI(): TerminalNode;
    statementLabel(): StatementLabelContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class CaseStatementContext extends ParserRuleContext {
    CASE(): TerminalNode;
    LPAREN(): TerminalNode;
    expression(): ExpressionContext;
    RPAREN(): TerminalNode;
    ENDCASE(): TerminalNode;
    statementLabel(): StatementLabelContext | undefined;
    switchBlockStatementGroup(): SwitchBlockStatementGroupContext[];
    switchBlockStatementGroup(i: number): SwitchBlockStatementGroupContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class EnumStatementContext extends ParserRuleContext {
    ENUM(): TerminalNode;
    IDENTIFIER(): TerminalNode;
    enumList(): EnumListContext;
    ENDENUM(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class BlockContext extends ParserRuleContext {
    statement(): StatementContext[];
    statement(i: number): StatementContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class VariableDeclarationInitializerContext extends ParserRuleContext {
    ASSIGN(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    EQUAL_DEPRECATED(): TerminalNode | undefined;
    ARRAY(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class EnumListContext extends ParserRuleContext {
    enumListEntry(): EnumListEntryContext[];
    enumListEntry(i: number): EnumListEntryContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class EnumListEntryContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode;
    ASSIGN(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class SwitchBlockStatementGroupContext extends ParserRuleContext {
    block(): BlockContext;
    switchLabel(): SwitchLabelContext[];
    switchLabel(i: number): SwitchLabelContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class SwitchLabelContext extends ParserRuleContext {
    COLON(): TerminalNode;
    integerLiteral(): IntegerLiteralContext | undefined;
    IDENTIFIER(): TerminalNode | undefined;
    STRING_LITERAL(): TerminalNode | undefined;
    DEFAULT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ForGroupContext extends ParserRuleContext {
    cstyleForStatement(): CstyleForStatementContext | undefined;
    basicForStatement(): BasicForStatementContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class BasicForStatementContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode;
    ASSIGN(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    TO(): TerminalNode;
    block(): BlockContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class CstyleForStatementContext extends ParserRuleContext {
    LPAREN(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    SEMI(): TerminalNode[];
    SEMI(i: number): TerminalNode;
    RPAREN(): TerminalNode;
    block(): BlockContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class IdentifierListContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode;
    COMMA(): TerminalNode | undefined;
    identifierList(): IdentifierListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class VariableDeclarationListContext extends ParserRuleContext {
    variableDeclaration(): VariableDeclarationContext[];
    variableDeclaration(i: number): VariableDeclarationContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class VariableDeclarationContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode;
    variableDeclarationInitializer(): VariableDeclarationInitializerContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ProgramParametersContext extends ParserRuleContext {
    LPAREN(): TerminalNode;
    RPAREN(): TerminalNode;
    programParameterList(): ProgramParameterListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ProgramParameterListContext extends ParserRuleContext {
    programParameter(): ProgramParameterContext[];
    programParameter(i: number): ProgramParameterContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ProgramParameterContext extends ParserRuleContext {
    UNUSED(): TerminalNode | undefined;
    IDENTIFIER(): TerminalNode;
    ASSIGN(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class FunctionParametersContext extends ParserRuleContext {
    LPAREN(): TerminalNode;
    RPAREN(): TerminalNode;
    functionParameterList(): FunctionParameterListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class FunctionParameterListContext extends ParserRuleContext {
    functionParameter(): FunctionParameterContext[];
    functionParameter(i: number): FunctionParameterContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class FunctionParameterContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode;
    BYREF(): TerminalNode | undefined;
    UNUSED(): TerminalNode | undefined;
    ASSIGN(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ScopedFunctionCallContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode;
    COLONCOLON(): TerminalNode;
    functionCall(): FunctionCallContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class FunctionReferenceContext extends ParserRuleContext {
    AT(): TerminalNode;
    IDENTIFIER(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ExpressionContext extends ParserRuleContext {
    _prefix: Token;
    _bop: Token;
    _postfix: Token;
    primary(): PrimaryContext | undefined;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    expressionSuffix(): ExpressionSuffixContext | undefined;
    INC(): TerminalNode | undefined;
    DEC(): TerminalNode | undefined;
    ADD(): TerminalNode | undefined;
    SUB(): TerminalNode | undefined;
    TILDE(): TerminalNode | undefined;
    BANG_A(): TerminalNode | undefined;
    BANG_B(): TerminalNode | undefined;
    MUL(): TerminalNode | undefined;
    DIV(): TerminalNode | undefined;
    MOD(): TerminalNode | undefined;
    LSHIFT(): TerminalNode | undefined;
    RSHIFT(): TerminalNode | undefined;
    BITAND(): TerminalNode | undefined;
    BITOR(): TerminalNode | undefined;
    CARET(): TerminalNode | undefined;
    ELVIS(): TerminalNode | undefined;
    TOK_IN(): TerminalNode | undefined;
    LE(): TerminalNode | undefined;
    GE(): TerminalNode | undefined;
    GT(): TerminalNode | undefined;
    LT(): TerminalNode | undefined;
    EQUAL_DEPRECATED(): TerminalNode | undefined;
    EQUAL(): TerminalNode | undefined;
    NOTEQUAL_B(): TerminalNode | undefined;
    NOTEQUAL_A(): TerminalNode | undefined;
    AND_A(): TerminalNode | undefined;
    AND_B(): TerminalNode | undefined;
    OR_A(): TerminalNode | undefined;
    OR_B(): TerminalNode | undefined;
    ADDMEMBER(): TerminalNode | undefined;
    DELMEMBER(): TerminalNode | undefined;
    CHKMEMBER(): TerminalNode | undefined;
    ASSIGN(): TerminalNode | undefined;
    ADD_ASSIGN(): TerminalNode | undefined;
    SUB_ASSIGN(): TerminalNode | undefined;
    MUL_ASSIGN(): TerminalNode | undefined;
    DIV_ASSIGN(): TerminalNode | undefined;
    MOD_ASSIGN(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class PrimaryContext extends ParserRuleContext {
    literal(): LiteralContext | undefined;
    parExpression(): ParExpressionContext | undefined;
    functionCall(): FunctionCallContext | undefined;
    scopedFunctionCall(): ScopedFunctionCallContext | undefined;
    IDENTIFIER(): TerminalNode | undefined;
    functionReference(): FunctionReferenceContext | undefined;
    explicitArrayInitializer(): ExplicitArrayInitializerContext | undefined;
    explicitStructInitializer(): ExplicitStructInitializerContext | undefined;
    explicitDictInitializer(): ExplicitDictInitializerContext | undefined;
    explicitErrorInitializer(): ExplicitErrorInitializerContext | undefined;
    bareArrayInitializer(): BareArrayInitializerContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ExplicitArrayInitializerContext extends ParserRuleContext {
    ARRAY(): TerminalNode;
    arrayInitializer(): ArrayInitializerContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ExplicitStructInitializerContext extends ParserRuleContext {
    STRUCT(): TerminalNode;
    structInitializer(): StructInitializerContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ExplicitDictInitializerContext extends ParserRuleContext {
    DICTIONARY(): TerminalNode;
    dictInitializer(): DictInitializerContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ExplicitErrorInitializerContext extends ParserRuleContext {
    TOK_ERROR(): TerminalNode;
    structInitializer(): StructInitializerContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class BareArrayInitializerContext extends ParserRuleContext {
    LBRACE(): TerminalNode;
    RBRACE(): TerminalNode;
    expressionList(): ExpressionListContext | undefined;
    COMMA(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ParExpressionContext extends ParserRuleContext {
    LPAREN(): TerminalNode;
    expression(): ExpressionContext;
    RPAREN(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ExpressionListContext extends ParserRuleContext {
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ExpressionSuffixContext extends ParserRuleContext {
    indexingSuffix(): IndexingSuffixContext | undefined;
    methodCallSuffix(): MethodCallSuffixContext | undefined;
    navigationSuffix(): NavigationSuffixContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class IndexingSuffixContext extends ParserRuleContext {
    LBRACK(): TerminalNode;
    expressionList(): ExpressionListContext;
    RBRACK(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class NavigationSuffixContext extends ParserRuleContext {
    DOT(): TerminalNode;
    IDENTIFIER(): TerminalNode | undefined;
    STRING_LITERAL(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class MethodCallSuffixContext extends ParserRuleContext {
    DOT(): TerminalNode;
    IDENTIFIER(): TerminalNode;
    LPAREN(): TerminalNode;
    RPAREN(): TerminalNode;
    expressionList(): ExpressionListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class FunctionCallContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode;
    LPAREN(): TerminalNode;
    RPAREN(): TerminalNode;
    expressionList(): ExpressionListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class StructInitializerExpressionContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode | undefined;
    ASSIGN(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    STRING_LITERAL(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class StructInitializerExpressionListContext extends ParserRuleContext {
    structInitializerExpression(): StructInitializerExpressionContext[];
    structInitializerExpression(i: number): StructInitializerExpressionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class StructInitializerContext extends ParserRuleContext {
    LBRACE(): TerminalNode;
    RBRACE(): TerminalNode;
    structInitializerExpressionList(): StructInitializerExpressionListContext | undefined;
    COMMA(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class DictInitializerExpressionContext extends ParserRuleContext {
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    ARROW(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class DictInitializerExpressionListContext extends ParserRuleContext {
    dictInitializerExpression(): DictInitializerExpressionContext[];
    dictInitializerExpression(i: number): DictInitializerExpressionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class DictInitializerContext extends ParserRuleContext {
    LBRACE(): TerminalNode;
    RBRACE(): TerminalNode;
    dictInitializerExpressionList(): DictInitializerExpressionListContext | undefined;
    COMMA(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class ArrayInitializerContext extends ParserRuleContext {
    LBRACE(): TerminalNode | undefined;
    RBRACE(): TerminalNode | undefined;
    expressionList(): ExpressionListContext | undefined;
    COMMA(): TerminalNode | undefined;
    LPAREN(): TerminalNode | undefined;
    RPAREN(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class LiteralContext extends ParserRuleContext {
    integerLiteral(): IntegerLiteralContext | undefined;
    floatLiteral(): FloatLiteralContext | undefined;
    CHAR_LITERAL(): TerminalNode | undefined;
    STRING_LITERAL(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class IntegerLiteralContext extends ParserRuleContext {
    DECIMAL_LITERAL(): TerminalNode | undefined;
    HEX_LITERAL(): TerminalNode | undefined;
    OCT_LITERAL(): TerminalNode | undefined;
    BINARY_LITERAL(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
export declare class FloatLiteralContext extends ParserRuleContext {
    FLOAT_LITERAL(): TerminalNode | undefined;
    HEX_FLOAT_LITERAL(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: EscriptParserListener): void;
    exitRule(listener: EscriptParserListener): void;
    accept<Result>(visitor: EscriptParserVisitor<Result>): Result;
}
