"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class CaseChangingStream {
    constructor(sourceName, stream, upper) {
        this.sourceName = sourceName;
        this.stream = stream;
        this.upper = upper;
    }
    LA(offset) {
        const c = this.stream.LA(offset);
        if (c <= 0) {
            return c;
        }
        return String.fromCodePoint(c)[this.upper ? 'toUpperCase' : 'toLowerCase']().codePointAt(0);
    }
    reset() {
        return this.stream.reset();
    }
    consume() {
        return this.stream.consume();
    }
    LT(offset) {
        return this.stream.LT(offset);
    }
    mark() {
        return this.stream.mark();
    }
    release(marker) {
        return this.stream.release(marker);
    }
    seek(_index) {
        return this.stream.seek(_index);
    }
    getText(interval) {
        return this.stream.getText(interval);
    }
    toString() {
        return this.stream.toString();
    }
    get index() {
        return this.stream.index;
    }
    get size() {
        return this.stream.size;
    }
}
exports.CaseChangingStream = CaseChangingStream;
